

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Poppler.Structs.ActionOCGState
    ( 

-- * Exported types
    ActionOCGState(..)                      ,
    newZeroActionOCGState                   ,
    noActionOCGState                        ,


 -- * Properties
-- ** StateList
    actionOCGStateReadStateList             ,


-- ** Title
    actionOCGStateReadTitle                 ,


-- ** Type
    actionOCGStateReadType                  ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Poppler.Types
import GI.Poppler.Callbacks

newtype ActionOCGState = ActionOCGState (ForeignPtr ActionOCGState)
-- | Construct a `ActionOCGState` struct initialized to zero.
newZeroActionOCGState :: MonadIO m => m ActionOCGState
newZeroActionOCGState = liftIO $ callocBytes 24 >>= wrapPtr ActionOCGState

noActionOCGState :: Maybe ActionOCGState
noActionOCGState = Nothing

actionOCGStateReadType :: ActionOCGState -> IO ActionType
actionOCGStateReadType s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

actionOCGStateReadTitle :: ActionOCGState -> IO T.Text
actionOCGStateReadTitle s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CString
    val' <- cstringToText val
    return val'

actionOCGStateReadStateList :: ActionOCGState -> IO ([Ptr ()])
actionOCGStateReadStateList s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO (Ptr (GList (Ptr ())))
    val' <- unpackGList val
    return val'

type family ResolveActionOCGStateMethod (t :: Symbol) (o :: *) :: * where
    ResolveActionOCGStateMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveActionOCGStateMethod t ActionOCGState, MethodInfo info ActionOCGState p) => IsLabelProxy t (ActionOCGState -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveActionOCGStateMethod t ActionOCGState, MethodInfo info ActionOCGState p) => IsLabel t (ActionOCGState -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


