

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

A #PopplerFormFieldMapping structure represents the location
of @field on the page
-}

module GI.Poppler.Structs.FormFieldMapping
    ( 

-- * Exported types
    FormFieldMapping(..)                    ,
    newZeroFormFieldMapping                 ,
    noFormFieldMapping                      ,


 -- * Methods
-- ** formFieldMappingCopy
    FormFieldMappingCopyMethodInfo          ,
    formFieldMappingCopy                    ,


-- ** formFieldMappingFree
    FormFieldMappingFreeMethodInfo          ,
    formFieldMappingFree                    ,


-- ** formFieldMappingNew
    formFieldMappingNew                     ,




 -- * Properties
-- ** Area
    formFieldMappingReadArea                ,


-- ** Field
    formFieldMappingReadField               ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Poppler.Types
import GI.Poppler.Callbacks

newtype FormFieldMapping = FormFieldMapping (ForeignPtr FormFieldMapping)
foreign import ccall "poppler_form_field_mapping_get_type" c_poppler_form_field_mapping_get_type :: 
    IO GType

instance BoxedObject FormFieldMapping where
    boxedType _ = c_poppler_form_field_mapping_get_type

-- | Construct a `FormFieldMapping` struct initialized to zero.
newZeroFormFieldMapping :: MonadIO m => m FormFieldMapping
newZeroFormFieldMapping = liftIO $ callocBoxedBytes 40 >>= wrapBoxed FormFieldMapping

noFormFieldMapping :: Maybe FormFieldMapping
noFormFieldMapping = Nothing

formFieldMappingReadArea :: FormFieldMapping -> IO Rectangle
formFieldMappingReadArea s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO (Ptr Rectangle)
    val' <- (newBoxed Rectangle) val
    return val'

formFieldMappingReadField :: FormFieldMapping -> IO FormField
formFieldMappingReadField s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 32) :: IO (Ptr FormField)
    val' <- (newObject FormField) val
    return val'

-- method FormFieldMapping::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- returnType : TInterface "Poppler" "FormFieldMapping"
-- throws : False
-- Skip return : False

foreign import ccall "poppler_form_field_mapping_new" poppler_form_field_mapping_new :: 
    IO (Ptr FormFieldMapping)


formFieldMappingNew ::
    (MonadIO m) =>
    m FormFieldMapping                      -- result
formFieldMappingNew  = liftIO $ do
    result <- poppler_form_field_mapping_new
    checkUnexpectedReturnNULL "poppler_form_field_mapping_new" result
    result' <- (wrapBoxed FormFieldMapping) result
    return result'

-- method FormFieldMapping::copy
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "_obj", argType = TInterface "Poppler" "FormFieldMapping", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : TInterface "Poppler" "FormFieldMapping"
-- throws : False
-- Skip return : False

foreign import ccall "poppler_form_field_mapping_copy" poppler_form_field_mapping_copy :: 
    Ptr FormFieldMapping ->                 -- _obj : TInterface "Poppler" "FormFieldMapping"
    IO (Ptr FormFieldMapping)


formFieldMappingCopy ::
    (MonadIO m) =>
    FormFieldMapping                        -- _obj
    -> m FormFieldMapping                   -- result
formFieldMappingCopy _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- poppler_form_field_mapping_copy _obj'
    checkUnexpectedReturnNULL "poppler_form_field_mapping_copy" result
    result' <- (wrapBoxed FormFieldMapping) result
    touchManagedPtr _obj
    return result'

data FormFieldMappingCopyMethodInfo
instance (signature ~ (m FormFieldMapping), MonadIO m) => MethodInfo FormFieldMappingCopyMethodInfo FormFieldMapping signature where
    overloadedMethod _ = formFieldMappingCopy

-- method FormFieldMapping::free
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "_obj", argType = TInterface "Poppler" "FormFieldMapping", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "poppler_form_field_mapping_free" poppler_form_field_mapping_free :: 
    Ptr FormFieldMapping ->                 -- _obj : TInterface "Poppler" "FormFieldMapping"
    IO ()


formFieldMappingFree ::
    (MonadIO m) =>
    FormFieldMapping                        -- _obj
    -> m ()                                 -- result
formFieldMappingFree _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    poppler_form_field_mapping_free _obj'
    touchManagedPtr _obj
    return ()

data FormFieldMappingFreeMethodInfo
instance (signature ~ (m ()), MonadIO m) => MethodInfo FormFieldMappingFreeMethodInfo FormFieldMapping signature where
    overloadedMethod _ = formFieldMappingFree

type family ResolveFormFieldMappingMethod (t :: Symbol) (o :: *) :: * where
    ResolveFormFieldMappingMethod "copy" o = FormFieldMappingCopyMethodInfo
    ResolveFormFieldMappingMethod "free" o = FormFieldMappingFreeMethodInfo
    ResolveFormFieldMappingMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveFormFieldMappingMethod t FormFieldMapping, MethodInfo info FormFieldMapping p) => IsLabelProxy t (FormFieldMapping -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveFormFieldMappingMethod t FormFieldMapping, MethodInfo info FormFieldMapping p) => IsLabel t (FormFieldMapping -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


